<script setup lang="ts">
    import {
        onBeforeMount,
        provide,
        ref,
        watch,
        computed,
        onUnmounted,
    } from 'vue'
    import {
        serviceOfferIdInjectionKey,
        serviceOfferInjectionKey,
        serviceOfferTrackingCategoryInjectionKey,
    } from '../constants'
    import { useMsal } from '@/plugins/msal/useMsal'
    import { ServiceOffer } from '@/serviceOffer/entities/serviceOffer/ServiceOffer'
    import { getAnalyticsProvider } from '../analytics/AnalyticsProvider'
    import { ServiceOfferApi } from '@/serviceOffer/entities/serviceOffer/ServiceOfferApi'
    import { RequestAborter } from '../api/entities/RequestAborter'
    import { SilabError } from '../errors/SilabError'
    import { useRoute } from 'vue-router'
    import { useUserStore } from '../user/stores/UserStore'
    import { isDefined } from '../helpers/types'
    import { silabColors } from '@/plugins/vuetify'

    const route = useRoute()
    const serviceOfferId = computed(() => {
        return <string>route.params.serviceOfferId
    })

    provide(serviceOfferIdInjectionKey, serviceOfferId)

    const msal = useMsal()
    const userStore = useUserStore(msal)
    const serviceOfferApi = new ServiceOfferApi(msal)

    const serviceOffer = ref<ServiceOffer | undefined>()

    provide(serviceOfferInjectionKey, serviceOffer)

    const serviceOfferTrackingCategory = computed(() => {
        return serviceOffer.value === undefined
            ? String(serviceOfferId.value)
            : `${serviceOffer.value.template}/${serviceOffer.value.title}`
    })

    provide(
        serviceOfferTrackingCategoryInjectionKey,
        serviceOfferTrackingCategory
    )
    const serviceOfferRequestAborter: RequestAborter = new RequestAborter()
    onBeforeMount(() => {
        watch(
            [() => msal.accounts, () => userStore.isImpersonating],
            () => {
                serviceOfferRequestAborter.abortRequestsAndRefreshAborter()
                serviceOfferApi
                    .get(
                        serviceOfferId.value,
                        serviceOfferRequestAborter.getSignal()
                    )
                    .then((fetchedServiceOffer) => {
                        serviceOffer.value = fetchedServiceOffer
                        getAnalyticsProvider().sendEvent(
                            'Offre de Service',
                            'Visite',
                            fetchedServiceOffer.title
                        )
                    })
                    .catch((error) => {
                        if (error.name !== 'AbortError') {
                            throw new SilabError(
                                `Erreur lors de la récupération de l'offre de service`,
                                error
                            )
                        }
                    })
            },
            { immediate: true }
        )
    })

    onUnmounted(() => {
        serviceOfferRequestAborter.abortRequests()
    })
</script>

<template>
    <router-view></router-view>
    <template
        v-if="isDefined(serviceOffer) && serviceOffer.environnement !== 'PROD'"
    >
        <div
            class="opacity-90 position-fixed top-0 right-0 bottom-0 left-0 d-print-none"
            style="z-index: 10000; pointer-events: none"
            :style="{
                boxShadow: `inset 0px 0px 20px -5px ${silabColors[serviceOffer.getEnvironnementColor()]}`,
                border: `2px solid ${silabColors[serviceOffer.getEnvironnementColor()]}`,
            }"
        >
            <v-chip
                :color="serviceOffer.getEnvironnementColor()"
                variant="flat"
                label
                class="environnement-chip position-fixed bottom-0 left-0"
            >
                <v-icon :icon="serviceOffer.getEnvironnementIcon()"></v-icon>
                <strong>
                    {{ serviceOffer.environnement }}
                </strong>
            </v-chip>
        </div>
        <div
            class="d-none d-print-block position-fixed bottom-0 left-0 text-disabled"
        >
            <v-icon :icon="serviceOffer.getEnvironnementIcon()"></v-icon>
            <strong>
                {{ serviceOffer.environnement }}
            </strong>
        </div>
    </template>
</template>
